package org.magmafoundation.bot.command.base;

import net.dv8tion.jda.api.entities.Member;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.TimeUnit;

public enum CheckTypes {
    COMMAND_NOT_FOUND,
    COMMAND_NO_PERMISSION,
    SUCCESS,
    COOLDOWN,
    SUPPRESSED_FAIL;

    public static final Map<Member, Long> cooldowns = new ConcurrentHashMap<>();

    public static boolean onCooldown(Member user) {
        if (cooldowns.containsKey(user)) {
            long time = cooldowns.get(user);
            long now = System.currentTimeMillis();
            long diff = now - time;
            if (diff >= TimeUnit.SECONDS.toMillis(5)) {
                cooldowns.remove(user);
                return false;
            }
            return true;
        }

        cooldowns.put(user, System.currentTimeMillis());
        return false;
    }
}
