package org.magmafoundation.bot.command.base;

import net.dv8tion.jda.api.JDA;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.channel.middleman.GuildMessageChannel;
import net.dv8tion.jda.api.events.interaction.command.SlashCommandInteractionEvent;

public class CommandContext {

    private final GuildMessageChannel channel;
    private final SlashCommandInteractionEvent slashCommandEvent;
    private final JDA jda;
    private final Member member;

    public CommandContext(GuildMessageChannel channel, SlashCommandInteractionEvent slashCommandEvent, Member member) {
        this.channel = channel;
        this.slashCommandEvent = slashCommandEvent;
        this.jda = slashCommandEvent.getJDA();
        this.member = member;
    }

    public GuildMessageChannel getChannel() {
        return channel;
    }

    public SlashCommandInteractionEvent getEvent() {
        return slashCommandEvent;
    }

    public JDA getJDA() {
        return jda;
    }

    public Member getMember() {
        return member;
    }
}
