package org.magmafoundation.bot.command.base;

import dev.JustRed23.jdautils.component.SendableComponent;
import dev.JustRed23.jdautils.component.interact.SmartReaction;
import dev.JustRed23.jdautils.event.EventWatcher;
import net.dv8tion.jda.api.entities.Guild;
import net.dv8tion.jda.api.entities.Message;
import net.dv8tion.jda.api.entities.Role;
import net.dv8tion.jda.api.events.message.react.MessageReactionAddEvent;
import net.dv8tion.jda.api.events.message.react.MessageReactionRemoveEvent;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import org.magmafoundation.bot.core.Magma;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;

public class CommandUtilities {
    private CommandUtilities() { throw new UnsupportedOperationException("This is a utility class and cannot be instantiated"); }
    private static final Logger LOGGER = LoggerFactory.getLogger(CommandUtilities.class);
    public static CheckTypes isMagmaRole(String role_id, CommandContext context) {
        final Guild guild = context.getJDA().getGuildById(Magma.guild_id);
        if (guild == null) return CheckTypes.SUPPRESSED_FAIL;
        final Role supermod = guild.getRoleById(role_id);
        if (supermod == null) return CheckTypes.SUPPRESSED_FAIL;
        if (context.getMember().getRoles().contains(supermod))
            return CheckTypes.SUCCESS;
        return CheckTypes.COMMAND_NO_PERMISSION;
    }
}
