package org.magmafoundation.bot.command.commands.admin;

import net.dv8tion.jda.api.interactions.commands.build.CommandData;
import net.dv8tion.jda.internal.interactions.CommandDataImpl;
import org.magmafoundation.bot.command.base.*;
import org.magmafoundation.bot.core.Magma;
import org.magmafoundation.bot.services.UpdateChecker;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings("unused")
public class UpdateCommand implements ICommand {
    private static final Logger LOGGER = LoggerFactory.getLogger(UpdateCommand.class);
    @Override
    public CheckTypes canUserExecute(CommandContext context) {
        return CommandUtilities.isMagmaRole(Magma.super_mod_role_id, context);
    }

    @Override
    public void execute(CommandContext context) {
        try {
            UpdateChecker.checkUpdate((message)->context.getEvent().reply(message).setEphemeral(true).complete());
        } catch (Exception e) {
            context.getEvent().reply("Update check failed").setEphemeral(true).queue();
            LOGGER.warn("Update check failed", e);
        }
    }

    @Override
    public String name() {
        return "update";
    }

    @Override
    public String help() {
        return "Manually check for MagmaBot updates";
    }

    @Override
    public CommandData commandData() {
        return new CommandDataImpl(name(), help());
    }

    @Override
    public Category category() {
        return Category.ADMIN;
    }
}
