package org.magmafoundation.bot.command.commands.info;

import net.dv8tion.jda.api.EmbedBuilder;
import net.dv8tion.jda.api.interactions.commands.build.CommandData;
import net.dv8tion.jda.api.interactions.commands.build.Commands;
import org.magmafoundation.bot.command.base.*;
import org.magmafoundation.bot.core.Magma;

import java.util.stream.Collectors;

public class HelpCommand implements ICommand {

   @Override
   public CheckTypes canUserExecute(CommandContext context) {
      return CheckTypes.SUCCESS;
   }

   @Override
   public void execute(CommandContext context) {
      EmbedBuilder embed = new EmbedBuilder()
              .setTitle("Magma Bot Help " + Magma.magma_emote)
              .setColor(Magma.embed_color);

      for (Category category : Category.values()) {
         String builder = CommandRegistry.getCommands().values().stream().filter(command -> command.category() == category).map(command -> "`" + command.name() + "` - " + command.help() + " \n").collect(Collectors.joining());
         embed.addField(category.name(), builder, false);
      }

      context.getEvent().replyEmbeds(embed.build()).queue();

   }

   @Override
   public String name() {
      return "help";
   }

   @Override
   public String help() {
      return "Display help";
   }

   @Override
   public CommandData commandData() {
      return Commands.slash(name(), help()).setGuildOnly(true);
   }

   @Override
   public Category category() {
      return Category.INFO;
   }
}

