package org.magmafoundation.bot.command.commands.info;

import net.dv8tion.jda.api.EmbedBuilder;
import net.dv8tion.jda.api.entities.MessageEmbed;
import net.dv8tion.jda.api.interactions.commands.build.CommandData;
import net.dv8tion.jda.api.interactions.commands.build.Commands;
import org.magmafoundation.bot.command.base.Category;
import org.magmafoundation.bot.command.base.CheckTypes;
import org.magmafoundation.bot.command.base.CommandContext;
import org.magmafoundation.bot.command.base.ICommand;
import org.magmafoundation.bot.core.Magma;

public class MemberCount implements ICommand {
   @Override
   public CheckTypes canUserExecute(CommandContext context) {
      return CheckTypes.SUCCESS;
   }

   @Override
   public void execute(CommandContext context) {
      MessageEmbed embed = new EmbedBuilder()
              .setTitle("Member Count " + Magma.magma_emote)
              .setDescription("There are currently " + context.getEvent().getGuild().getMemberCount() + " members in this server.")
              .setColor(Magma.embed_color)
              .build();
      context.getEvent().replyEmbeds(embed).queue();

   }

   @Override
   public String name() {
      return "membercount";
   }

   @Override
   public String help() {
      return "Shows the member count of the server";
   }

   @Override
   public CommandData commandData() {
      return Commands.slash(name(), help()).setGuildOnly(true);
   }

   @Override
   public Category category() {
      return Category.INFO;
   }
}
