package org.magmafoundation.bot.db.tables;

import org.magmafoundation.bot.db.Table;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import static org.magmafoundation.bot.db.DatabaseManager.getConnection;

public class ActivityTable extends Table<ActivityTable.Activity> {

    public record Activity(String activity) {}

    protected void createTable() throws SQLException {
        StringBuilder sql = new StringBuilder();
        sql.append("CREATE TABLE IF NOT EXISTS activity (");
        sql.append("  id INTEGER PRIMARY KEY AUTO_INCREMENT,");
        sql.append("  activity TEXT,");
        sql.append("  created_at DATETIME DEFAULT CURRENT_TIMESTAMP");
        sql.append(");");
        getConnection().createStatement().executeUpdate(sql.toString());
    }

    public Activity get(Object... args) throws SQLException {
        PreparedStatement statement = getConnection().prepareStatement("SELECT * FROM activity ORDER BY id DESC LIMIT 1");
        ResultSet resultSet = statement.executeQuery();
        if (resultSet.next()) {
            return new Activity(resultSet.getString("activity"));
        }
        return null;
    }

    public void add(Object... args) throws SQLException {
        String activity = (String) args[0];

        PreparedStatement statement = getConnection().prepareStatement("INSERT INTO activity (activity) VALUES (?)");
        statement.setString(1, activity);
        statement.executeUpdate();
    }
}
