package org.magmafoundation.bot.services;

import dev.JustRed23.stonebrick.log.SBLogger;
import dev.JustRed23.stonebrick.service.Service;
import org.magmafoundation.bot.AppMain;
import org.magmafoundation.bot.command.base.CommandRegistry;
import org.magmafoundation.bot.event.BaseEventListener;
import org.slf4j.Logger;

import java.util.concurrent.TimeUnit;

public class UpdateSlashCommands extends Service {

    private static final Logger LOGGER = SBLogger.getLogger(UpdateSlashCommands.class);

    public static boolean collectedSlashCommands = false;

    public boolean shouldRun() {
        return BaseEventListener.ready && collectedSlashCommands;
    }

    public long delayBetweenRuns() {
        return TimeUnit.SECONDS.toMillis(30);
    }

    public void run() throws Exception {
        LOGGER.warn("Updating slash commands");
        addSlashCommands();
    }

    public static void addSlashCommands() {
        AppMain.getInstance().updateCommands().addCommands(CommandRegistry.compileCommandData()).queue();
        AppMain.getInstance().getGuilds().forEach(guild -> guild.updateCommands().queue());
    }

    public void onComplete() {
        super.onComplete();
        if (collectedSlashCommands)
            collectedSlashCommands = false;
    }
}
