package org.magmafoundation.bot.update;

import dev.JustRed23.stonebrick.log.SBLogger;
import org.gitlab4j.api.models.Release;
import org.jetbrains.annotations.NotNull;
import org.magmafoundation.bot.utils.JarUtils;
import org.slf4j.Logger;

import java.io.FileOutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.channels.Channels;
import java.nio.channels.ReadableByteChannel;

public class AutoUpdate {

    private static final Logger LOGGER = SBLogger.getLogger(AutoUpdate.class);

    public static void updateFound(@NotNull Release latest) {
        LOGGER.info("Update found: " + latest.getCommit().getShortId());

        String url = latest.getAssets().getLinks().get(0).getUrl(); //get the all.jar url
        LOGGER.info("Downloading update from: " + url);

        try {
            URL website = new URL(url);
            HttpURLConnection connection = (HttpURLConnection) website.openConnection();
            connection.setRequestMethod("GET");
            connection.addRequestProperty("User-Agent", "MagmaBot");
            ReadableByteChannel rbc = Channels.newChannel(connection.getInputStream());

            try (FileOutputStream fos = new FileOutputStream(JarUtils.getJarFile())) {
                fos.getChannel().transferFrom(rbc, 0, Long.MAX_VALUE);
            }

            rbc.close();
            connection.disconnect();

            LOGGER.info("Update downloaded, restarting...");
            System.exit(0);
        } catch (Exception e) {
            LOGGER.error("Error while downloading update", e);
        }
    }
}
